/$ CConverter.c

generateMemo(string form, int nctls, pointer p)
{
int i,j,id,height;

id = 5000;
mmputs("#define FORM1 "+id++ +"\n");
for(i=0; i<nctls; i++)
{
  switch (p[i].type)
  {
  case TYPE_RADIO:
    for(j=0; j<p[i].strings[0]; j++)
      mmputs("#define " + p[i].name+
       j+" " + id++ + "\n");
    break;
  case TYPE_DROPDOWN:
    mmputs("#define " + p[i].name+"TRIG "+
     id++ + "\n");
    // fall through to define the id of list
  default:
    mmputs("#define " + p[i].name + " " + id++ + "\n");
  }  
}
mmputs("init_controls()\n{\n");
mmputs("int pos,font_height;\n");
mmputs("pointer p;\n");
mmputs("font_height=FontHeight();\n");
for(i=0; i<nctls; i++)
{
  switch(p[i].type)
  {
  case TYPE_LABEL:
    mmputs(
     "Label("+p[i].name+","+
     p[i].left+","+
     p[i].top+",\""+
     p[i].text+"\");\n");
    break;
  case TYPE_BUTTON:
    mmputs(
     "Button("+
     p[i].name+",0,"+
     p[i].left+","+
     p[i].top+","+
     p[i].width+
     ",font_height,\""+
     p[i].text+"\");\n");
    break;
  case TYPE_SWITCH:
    mmputs(
     "Button("+
     p[i].name+",1,"+
     p[i].left+","+
     p[i].top+","+
     p[i].width+
     ",font_height,\""+
     p[i].text+"\");\n");
    break;
  case TYPE_CHECKBOX:
    mmputs(
     "Button("+
     p[i].name+",2,"+
     p[i].left+","+
     p[i].top+","+
     p[i].width+
     ",font_height,\""+
     p[i].text+"\");\n");
    break;
  case TYPE_EDIT:
    mmputs(
     "Field("+
     p[i].name+",0,"+
     p[i].left+","+
     p[i].top+","+
     p[i].width+
     ",font_height,255,\""+
     p[i].text+"\");\n");
    break;
  case TYPE_RADIO:
    mmputs("pos="+p[i].left+";\n");
    for (j=0; j<p[i].strings[0]; j++)
      mmputs(
       "pos=Button("+
       p[i].name+j+","+
       (BTN_PUSH | 
        BTN_GROUP(p[i].index+1))+
       ",pos,"+
       p[i].top+",0"+
       ",font_height,\""+
       p[i].strings[1][j]+"\");\n");
    mmputs("FsetState("+
     p[i].name+"0,1);\n");
    break;        
  case TYPE_LISTBOX:
    mmputs("p=malloct("+
     p[i].strings[0]+",\"s\");\n");
     for (j=0; j<p[i].strings[0]; j++)
       mmputs("p["+j+"]=\""+
        p[i].strings[1][j]+"\";\n");
     mmputs("List("+p[i].name+","+
      p[i].left+","+
      p[i].top+","+
      p[i].width+","+ 
      (p[i].height/11)+",0);\n");
     mmputs("FsetList("+p[i].name+
      ",-1,"+p[i].strings[0]+
      ",p);\n");
     break;
  case TYPE_DROPDOWN:
    mmputs("p=malloct("+
     p[i].strings[0]+",\"s\");\n");
     for (j=0; j<p[i].strings[0]; j++)
       mmputs("p["+j+"]=\""+
        p[i].strings[1][j]+"\";\n");
     mmputs("List("+p[i].name+","+
      p[i].left+","+
      p[i].top+","+
      p[i].width+","+ 
      (p[i].height/11)+","+
      p[i].name+"TRIG);\n");
     mmputs("FsetList("+p[i].name+
      ",-1,"+p[i].strings[0]+
      ",p);\n");
     mmputs("Button("+
      p[i].name+"TRIG,3,"+
      p[i].left+","+
      p[i].top+
      ",0,font_height,\"\");\n");
    break;
  }
  free(p[i].strings[1]);
  free(p[i].strings);
}
mmputs("}\n");
free(p);
}
